import { DestroyRef, NgZone, Signal, TemplateRef, ViewContainerRef, WritableSignal } from '@angular/core';
import { IEnjoyHintOptions, ITutorialStep } from '../lib.interfaces';
import { EnjoyHintRef } from '../support/EnjoyHintRef';
import { Observable } from 'rxjs';
import { ConnectionPositionPair, Overlay, OverlayPositionBuilder, PositionStrategy } from '@angular/cdk/overlay';
import * as i0 from "@angular/core";
export declare class EnjoyHintComponent {
    readonly ref: EnjoyHintRef;
    private readonly overlayPositionBuilder;
    private readonly overlay;
    private readonly viewContainerRef;
    private readonly destroyedRef;
    private readonly zone;
    instructions: TemplateRef<any>;
    readonly opacity: string;
    static readonly defaultOptions: IEnjoyHintOptions;
    readonly viewSize: Signal<{
        width: number;
        height: number;
    }>;
    readonly ffSize: Signal<{
        width: number;
        height: number;
    }>;
    readonly instructionsWidth: Signal<number>;
    readonly animating: WritableSignal<boolean>;
    readonly focusElement: Signal<HTMLElement>;
    readonly elementBounds: Signal<DOMRect>;
    readonly ffPositions: Signal<{
        left: {
            x: number;
            y: number;
        };
        right: {
            x: number;
            y: number;
        };
        top: {
            x: number;
            y: number;
        };
        bottom: {
            x: number;
            y: number;
        };
    }>;
    readonly step: Signal<ITutorialStep | undefined>;
    readonly options: IEnjoyHintOptions;
    private overlayRef;
    readonly positionStrategy: Signal<PositionStrategy>;
    readonly position: WritableSignal<ConnectionPositionPair | undefined>;
    thisIsDestroyed: Observable<void>;
    /**
     * instead of doing actual padding around the focus element (which would allow clicks)
     * outside of the focus element), we'll add some glow around wht focus element but still
     * on the force field
     *
     * white must be used as anything semi-transparent or transparent will not show up
     *
     * @see https://developer.mozilla.org/en-US/docs/Web/CSS/box-shadow#length
     */
    readonly focusElementHighlight: Signal<string>;
    constructor(ref: EnjoyHintRef, window: Window, overlayPositionBuilder: OverlayPositionBuilder, overlay: Overlay, viewContainerRef: ViewContainerRef, destroyedRef: DestroyRef, zone: NgZone);
    createOverlay(): void;
    previous(): void;
    next(): Promise<void>;
    skip(): void;
    close(result?: boolean): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<EnjoyHintComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EnjoyHintComponent, "lib-enjoyhint", never, {}, {}, never, never, true, never>;
}
